﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DotNetCore.BannerManagement.Domain;
using System.Data.SqlClient;
using System.Diagnostics;
using Microsoft.Practices.Repository;
using Microsoft.Practices.Repository.SQLServer;

namespace DotNetCore.BannerManagement.DAL.Domain.dnc_ClickThroughRepositoryArtifacts
{
    /// <summary>
    /// Respository that lets you find dnc_ClickThrough in the
    /// CRM database.
    /// </summary>
    public class dnc_ClickThroughRepository : Repository<dnc_ClickThrough>, Idnc_ClickThroughRepository
    {
        public dnc_ClickThroughRepository(string databaseName)
            : base(databaseName)
        {
        }

        public dnc_ClickThroughRepository()
            : base()
        {
        }


        public List<dnc_ClickThrough> GetAllFromdnc_ClickThrough()
        {
            ISelectionFactory<NullableIdentity> selectionFactory = new GetAllFromdnc_ClickThroughSelectionFactory();

            try
            {
                NullableIdentity nullableIdentity = new NullableIdentity();
                return base.Find(selectionFactory, new GetAllFromdnc_ClickThroughFactory(), nullableIdentity);
            }
            catch (SqlException ex)
            {
                HandleSqlException(ex, selectionFactory);
            }

            return new List<dnc_ClickThrough>();
        }

        public void Add(dnc_ClickThrough dnc_ClickThrough)
        {
            dnc_ClickThroughInsertFactory insertFactory = new dnc_ClickThroughInsertFactory();
            try
            {
                base.Add(insertFactory, dnc_ClickThrough);
            }
            catch (SqlException ex)
            {
                HandleSqlException(ex, insertFactory);
            }
        }

        private void HandleSqlException(SqlException ex, IDbToBusinessEntityNameMapper mapper)
        {
            if (ex.Number == ErrorCodes.SqlUserRaisedError)
            {
                switch (ex.State)
                {
                    case ErrorCodes.ValidationError:
                        string[] messageParts = ex.Errors[0].Message.Split(':');
                        throw new RepositoryValidationException(
                            mapper.MapDbParameterToBusinessEntityProperty(messageParts[0]),
                            messageParts[1], ex);

                    case ErrorCodes.ConcurrencyViolationError:
                        throw new ConcurrencyViolationException(ex.Message, ex);

                }
            }

            throw new RepositoryFailureException(ex);
        }
    }
}

