﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DotNetCore.BannerManagement.Domain;
using System.Data.SqlClient;
using System.Diagnostics;
using Microsoft.Practices.Repository;
using Microsoft.Practices.Repository.SQLServer;

namespace DotNetCore.BannerManagement.DAL.Domain.dnc_ImageRepositoryArtifacts
{
    /// <summary>
    /// Respository that lets you find dnc_Image in the
    /// CRM database.
    /// </summary>
    public class dnc_ImageRepository : Repository<dnc_Image>, Idnc_ImageRepository 
    {
        public dnc_ImageRepository(string databaseName)
            : base(databaseName)
        {
        }
        
        public dnc_ImageRepository() : base()
        {
        }
        

		public List<dnc_Image> GetAllFromdnc_Image()
        {
            ISelectionFactory<NullableIdentity> selectionFactory = new GetAllFromdnc_ImageSelectionFactory();
            
            try
            {
				NullableIdentity nullableIdentity = new NullableIdentity();
				return base.Find(selectionFactory, new GetAllFromdnc_ImageFactory(), nullableIdentity);
			}
            catch (SqlException ex)
            {
                HandleSqlException(ex, selectionFactory);
            }
            
            return new List<dnc_Image>();
        }

		public dnc_Image Getdnc_ImageByID(System.Int32 iD)
        {
            ISelectionFactory<System.Int32> selectionFactory = new Getdnc_ImageByIDSelectionFactory();
            
            try
            {
				return base.FindOne(selectionFactory, new Getdnc_ImageByIDFactory(), iD);
			}
            catch (SqlException ex)
            {
                HandleSqlException(ex, selectionFactory);
            }
            
			return new dnc_Image();
        }

        public void Add(dnc_Image dnc_Image)
        {
            dnc_ImageInsertFactory insertFactory = new dnc_ImageInsertFactory();
            try
            {
                base.Add(insertFactory, dnc_Image);
            }
            catch (SqlException ex)
            {
                HandleSqlException(ex, insertFactory);
            }
        }

        public void Remove(System.Int32 iD)
        {
			IDeleteFactory<System.Int32> deleteFactory = new dnc_ImageDeleteFactory();

            try
            {
				base.Remove(deleteFactory, iD);
            }
            catch (SqlException ex)
            {
                HandleSqlException(ex, deleteFactory);
            }            
        }
      

		public void Save(dnc_Image dnc_Image)
        {
            dnc_ImageUpdateFactory updateFactory = new dnc_ImageUpdateFactory();
            try
            {
                base.Save(updateFactory, dnc_Image);
            }
            catch (SqlException ex)
            {
                HandleSqlException(ex, updateFactory);
            }
        }

        private void HandleSqlException(SqlException ex, IDbToBusinessEntityNameMapper mapper)
        {
            if(ex.Number == ErrorCodes.SqlUserRaisedError)
            {
                switch(ex.State)
                {
                    case ErrorCodes.ValidationError:
                        string[] messageParts = ex.Errors[0].Message.Split(':');
                        throw new RepositoryValidationException(
                            mapper.MapDbParameterToBusinessEntityProperty(messageParts[0]),
                            messageParts[1], ex);

                    case ErrorCodes.ConcurrencyViolationError:
                        throw new ConcurrencyViolationException(ex.Message, ex);

                }
            }

            throw new RepositoryFailureException(ex);
        }
    }
}

