﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;
using System.Text;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DotNetCore.BannerManagement.Domain;
using DotNetCore.BannerManagement.Domain;
using Microsoft.Practices.Repository;
using System.Globalization;
using System.Data.SqlClient; 


namespace DotNetCore.BannerManagement.DAL.Domain.dnc_ZoneImageRepositoryArtifacts
{
    /// <summary>
    /// This factory class takes a dnc_ZoneImage object and generates
    /// the dbcommand object needed to call the underlying update
    /// stored proc.
    /// </summary>
    internal class dnc_ZoneImageUpdateFactory : IDbToBusinessEntityNameMapper, IUpdateFactory<dnc_ZoneImage>
    {
        /// <summary>
        /// Creates the dnc_ZoneImageUpdateFactory to build an update statement for
        /// the given dnc_ZoneImage object.
        /// </summary>
        public dnc_ZoneImageUpdateFactory()
        {
        }
        
        #region IUpdateFactory<dnc_ZoneImage> Members

        public DbCommand ConstructUpdateCommand(Database db, dnc_ZoneImage dnc_ZoneImage)
        {
			DbCommand command = db.GetStoredProcCommand("Updatednc_ZoneImage");
			
			    db.AddInParameter(command, "id", DbType.Int32, dnc_ZoneImage.Id);
			    db.AddInParameter(command, "imageHeight", DbType.Decimal, dnc_ZoneImage.ImageHeight);
			    db.AddInParameter(command, "imageWidth", DbType.Decimal, dnc_ZoneImage.ImageWidth);
			if(dnc_ZoneImage.Name == null)
            {
                db.AddInParameter(command, "name", DbType.String);
            }
            else
            {
			    db.AddInParameter(command, "name", DbType.String, dnc_ZoneImage.Name);
            }

			return command;
        }
        #endregion
        
		#region IDbToBusinessEntityNameMapper Members
        /// <summary>
        /// Maps a field name in the database (usually a parameter name for a stored proc)
        /// to the corresponding business entity property name.
        /// </summary>
        /// <remarks>This method is intended for error message handling, not for reflection.</remarks>
        /// <param name="dbParameter">Name of field/parameter that the database knows about.</param>
        /// <returns>Corresponding business entity field name.</returns>
        public string MapDbParameterToBusinessEntityProperty(string dbParameter)
        {
            switch (dbParameter)
            {
				case "id":
					return "Id";
				case "imageHeight":
					return "ImageHeight";
				case "imageWidth":
					return "ImageWidth";
				case "name":
					return "Name";
				default:
					throw new Exception(dbParameter);
			}
        }
        #endregion        
    }
}

